diff --git a/board/ifm/o2dnt2/o2dnt2.c b/board/ifm/o2dnt2/o2dnt2.c
index 6716ffc..5a92de9 100644
--- a/board/ifm/o2dnt2/o2dnt2.c
+++ b/board/ifm/o2dnt2/o2dnt2.c
@@ -93,9 +93,9 @@ phys_size_t initdram(int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
@@ -122,11 +122,11 @@ phys_size_t initdram(int board_type)
 	if (!dramsize)
 		sdram_start(0);
 
-	test2 = test1 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize),
+	test2 = test1 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize),
 					0x80000000);
 	if (!dramsize) {
 		sdram_start(1);
-		test2 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize),
+		test2 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize),
 					0x80000000);
 	}
 
diff --git a/board/imx31_phycore/imx31_phycore.c b/board/imx31_phycore/imx31_phycore.c
index 3f45e4e..4d400a1 100644
--- a/board/imx31_phycore/imx31_phycore.c
+++ b/board/imx31_phycore/imx31_phycore.c
@@ -18,7 +18,7 @@ DECLARE_GLOBAL_DATA_PTR;
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM_1,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM_1,
 				PHYS_SDRAM_1_SIZE);
 	return 0;
 }
diff --git a/board/in-circuit/grasshopper/grasshopper.c b/board/in-circuit/grasshopper/grasshopper.c
index 340b713..4124f1e 100644
--- a/board/in-circuit/grasshopper/grasshopper.c
+++ b/board/in-circuit/grasshopper/grasshopper.c
@@ -73,7 +73,7 @@ phys_size_t initdram(int board_type)
 {
 	unsigned long expected_size;
 	unsigned long actual_size;
-	void *sdram_base;
+	unsigned long *sdram_base;
 
 	sdram_base = uncached(EBI_SDRAM_BASE);
 
diff --git a/board/incaip/incaip.c b/board/incaip/incaip.c
index 911fb63..72afd4b 100644
--- a/board/incaip/incaip.c
+++ b/board/incaip/incaip.c
@@ -59,7 +59,7 @@ phys_size_t initdram(int board_type)
 		{
 			*INCA_IP_SDRAM_MC_CFGPB0 = (0x14 << 8) |
 			                           (rows << 4) | cols;
-			size = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE,
+			size = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE,
 			                                     max_sdram_size());
 
 			if (size > max_size)
diff --git a/board/inka4x0/inka4x0.c b/board/inka4x0/inka4x0.c
index fc3333e..644ff0f 100644
--- a/board/inka4x0/inka4x0.c
+++ b/board/inka4x0/inka4x0.c
@@ -87,7 +87,7 @@ phys_size_t initdram (int board_type)
 		(struct mpc5xxx_sdram *)    MPC5XXX_SDRAM;
 	ulong dramsize = 0;
 #ifndef CONFIG_SYS_RAMBOOT
-	long test1, test2;
+	unsigned long test1, test2;
 
 	/* setup SDRAM chip selects */
 	out_be32(&mm->sdram0, 0x0000001c);	/* 512MB at 0x0 */
@@ -104,9 +104,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/intercontrol/digsy_mtc/digsy_mtc.c b/board/intercontrol/digsy_mtc/digsy_mtc.c
index 5843725..5718b85 100644
--- a/board/intercontrol/digsy_mtc/digsy_mtc.c
+++ b/board/intercontrol/digsy_mtc/digsy_mtc.c
@@ -97,9 +97,9 @@ phys_size_t initdram(int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x08000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
@@ -123,7 +123,7 @@ phys_size_t initdram(int board_type)
 	out_be32((void *)MPC5XXX_SDRAM_CS1CFG, dramsize + 0x0000001C);
 
 	/* find RAM size using SDRAM CS1 only */
-	test1 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize),
+	test1 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize),
 			0x08000000);
 		dramsize2 = test1;
 
diff --git a/board/ip860/ip860.c b/board/ip860/ip860.c
index 4e3b1b5..7447916 100644
--- a/board/ip860/ip860.c
+++ b/board/ip860/ip860.c
@@ -240,7 +240,8 @@ static long int dram_size (long int mamr_value, long int *base,
 
 	memctl->memc_mamr = mamr_value;
 
-	return (get_ram_size(base, maxsize));
+	return (long int)(get_ram_size((unsigned long *)base,
+				(unsigned long)maxsize));
 }
 
 /* ------------------------------------------------------------------------- */
diff --git a/board/ipek01/ipek01.c b/board/ipek01/ipek01.c
index d44c4bf..c3cf3d6 100644
--- a/board/ipek01/ipek01.c
+++ b/board/ipek01/ipek01.c
@@ -103,9 +103,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start (0);
-	test1 = get_ram_size ((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size ((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start (1);
-	test2 = get_ram_size ((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size ((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start (0);
 		dramsize = test1;
diff --git a/board/iphase4539/iphase4539.c b/board/iphase4539/iphase4539.c
index d40d2b6..24a7be6 100644
--- a/board/iphase4539/iphase4539.c
+++ b/board/iphase4539/iphase4539.c
@@ -220,7 +220,7 @@ phys_size_t initdram (int board_type)
 	 */
 	maxsize = (1 + (~memctl->memc_or1 | 0x7fff)) / 2;
 
-	maxsize = get_ram_size((long *)base, maxsize);
+	maxsize = get_ram_size((unsigned long *)base, maxsize);
 
 	memctl->memc_or1 |= ~(maxsize - 1);
 
diff --git a/board/ispan/ispan.c b/board/ispan/ispan.c
index c610c3b..cb274c1 100644
--- a/board/ispan/ispan.c
+++ b/board/ispan/ispan.c
@@ -398,7 +398,7 @@ phys_size_t initdram (int board_type)
 	 */
 	maxsize = (~(memctl->memc_or1 & BRx_BA_MSK) + 1) / 2;
 
-	maxsize = get_ram_size((long *)(memctl->memc_br1 & BRx_BA_MSK), maxsize);
+	maxsize = (long)get_ram_size((unsigned long *)(memctl->memc_br1 & BRx_BA_MSK), maxsize);
 
 	memctl->memc_or1 |= ~(maxsize - 1);
 
diff --git a/board/ivm/ivm.c b/board/ivm/ivm.c
index 3bdbdd1..3529818 100644
--- a/board/ivm/ivm.c
+++ b/board/ivm/ivm.c
@@ -261,7 +261,8 @@ static long int dram_size (long int mamr_value, long int *base,
 
 	memctl->memc_mbmr = mamr_value;
 
-	return (get_ram_size (base, maxsize));
+	return (long int)(get_ram_size ((unsigned long)base,
+				(unsigned long)maxsize));
 }
 
 /* ------------------------------------------------------------------------- */
diff --git a/board/jupiter/jupiter.c b/board/jupiter/jupiter.c
index 78e4b5d..2c0b4e3 100644
--- a/board/jupiter/jupiter.c
+++ b/board/jupiter/jupiter.c
@@ -103,9 +103,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
@@ -131,10 +131,10 @@ phys_size_t initdram (int board_type)
 	/* find RAM size using SDRAM CS1 only */
 	if (!dramsize)
 		sdram_start(0);
-	test2 = test1 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
+	test2 = test1 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
 	if (!dramsize) {
 		sdram_start(1);
-		test2 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
+		test2 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
 	}
 	if (test1 > test2) {
 		sdram_start(0);
diff --git a/board/karo/tx25/tx25.c b/board/karo/tx25/tx25.c
index 4d1a0ec..9abb801 100644
--- a/board/karo/tx25/tx25.c
+++ b/board/karo/tx25/tx25.c
@@ -184,7 +184,7 @@ int board_late_init(void)
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM_1,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM_1,
 				PHYS_SDRAM_1_SIZE);
 	return 0;
 }
@@ -192,11 +192,11 @@ int dram_init(void)
 void dram_init_banksize(void)
 {
 	gd->bd->bi_dram[0].start = PHYS_SDRAM_1;
-	gd->bd->bi_dram[0].size = get_ram_size((void *)PHYS_SDRAM_1,
+	gd->bd->bi_dram[0].size = get_ram_size((unsigned long *)PHYS_SDRAM_1,
 			PHYS_SDRAM_1_SIZE);
 #if CONFIG_NR_DRAM_BANKS > 1
 	gd->bd->bi_dram[1].start = PHYS_SDRAM_2;
-	gd->bd->bi_dram[1].size = get_ram_size((void *)PHYS_SDRAM_2,
+	gd->bd->bi_dram[1].size = get_ram_size((unsigned long *)PHYS_SDRAM_2,
 			PHYS_SDRAM_2_SIZE);
 #else
 
diff --git a/board/keymile/km82xx/km82xx.c b/board/keymile/km82xx/km82xx.c
index dfbfab8..b69958e 100644
--- a/board/keymile/km82xx/km82xx.c
+++ b/board/keymile/km82xx/km82xx.c
@@ -236,7 +236,7 @@ static long int try_init(memctl8260_t *memctl, ulong sdmr,
 	out_be32(&memctl->memc_psdmr, sdmr | PSDMR_OP_NORM | PSDMR_RFEN);
 	out_8(base, c);
 
-	size = get_ram_size((long *)base, maxsize);
+	size = get_ram_size((unsigned long *)base, maxsize);
 	out_be32(&memctl->memc_or1, orx | ~(size - 1));
 
 	return size;
diff --git a/board/logicpd/imx27lite/imx27lite.c b/board/logicpd/imx27lite/imx27lite.c
index 07b07a0..0d4eae3 100644
--- a/board/logicpd/imx27lite/imx27lite.c
+++ b/board/logicpd/imx27lite/imx27lite.c
@@ -52,7 +52,7 @@ int board_init(void)
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)CONFIG_SYS_SDRAM_BASE,
+	gd->ram_size = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE,
 				PHYS_SDRAM_1_SIZE);
 	return 0;
 }
@@ -60,11 +60,11 @@ int dram_init(void)
 void dram_init_banksize(void)
 {
 	gd->bd->bi_dram[0].start = CONFIG_SYS_SDRAM_BASE;
-	gd->bd->bi_dram[0].size = get_ram_size((void *)CONFIG_SYS_SDRAM_BASE,
+	gd->bd->bi_dram[0].size = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE,
 			PHYS_SDRAM_1_SIZE);
 #if CONFIG_NR_DRAM_BANKS > 1
 	gd->bd->bi_dram[1].start = PHYS_SDRAM_2;
-	gd->bd->bi_dram[1].size = get_ram_size((void *)PHYS_SDRAM_2,
+	gd->bd->bi_dram[1].size = get_ram_size((unsigned long *)PHYS_SDRAM_2,
 			PHYS_SDRAM_2_SIZE);
 #endif
 }
diff --git a/board/logicpd/imx31_litekit/imx31_litekit.c b/board/logicpd/imx31_litekit/imx31_litekit.c
index 386e106..e5ed1e0 100644
--- a/board/logicpd/imx31_litekit/imx31_litekit.c
+++ b/board/logicpd/imx31_litekit/imx31_litekit.c
@@ -17,7 +17,7 @@ DECLARE_GLOBAL_DATA_PTR;
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM_1,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM_1,
 				PHYS_SDRAM_1_SIZE);
 	return 0;
 }
diff --git a/board/lwmon/lwmon.c b/board/lwmon/lwmon.c
index 225b1ef..5166d66 100644
--- a/board/lwmon/lwmon.c
+++ b/board/lwmon/lwmon.c
@@ -315,7 +315,7 @@ static long int dram_size (long int mamr_value, long int *base, long int maxsize
 
 	memctl->memc_mamr = mamr_value;
 
-	return (get_ram_size(base, maxsize));
+	return (long int)(get_ram_size((unsigned long *)base, (unsigned long)maxsize));
 }
 
 /* ------------------------------------------------------------------------- */
diff --git a/board/manroland/hmi1001/hmi1001.c b/board/manroland/hmi1001/hmi1001.c
index 781f10b..da6c04b 100644
--- a/board/manroland/hmi1001/hmi1001.c
+++ b/board/manroland/hmi1001/hmi1001.c
@@ -89,9 +89,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/manroland/mucmc52/mucmc52.c b/board/manroland/mucmc52/mucmc52.c
index 63dc2ad..17166cf 100644
--- a/board/manroland/mucmc52/mucmc52.c
+++ b/board/manroland/mucmc52/mucmc52.c
@@ -102,9 +102,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start (0);
-	test1 = get_ram_size ((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test1 = get_ram_size ((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	sdram_start(1);
-	test2 = get_ram_size ((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test2 = get_ram_size ((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	if (test1 > test2) {
 		sdram_start (0);
 		dramsize = test1;
@@ -131,10 +131,10 @@ phys_size_t initdram (int board_type)
 	/* find RAM size using SDRAM CS1 only */
 	if (!dramsize)
 		sdram_start (0);
-	test2 = test1 = get_ram_size ((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x20000000);
+	test2 = test1 = get_ram_size ((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x20000000);
 	if (!dramsize) {
 		sdram_start (1);
-		test2 = get_ram_size ((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x20000000);
+		test2 = get_ram_size ((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x20000000);
 	}
 	if (test1 > test2) {
 		sdram_start (0);
diff --git a/board/manroland/uc101/uc101.c b/board/manroland/uc101/uc101.c
index 6e1246e..b07d009 100644
--- a/board/manroland/uc101/uc101.c
+++ b/board/manroland/uc101/uc101.c
@@ -155,9 +155,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x20000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/matrix_vision/mvbc_p/mvbc_p.c b/board/matrix_vision/mvbc_p/mvbc_p.c
index 8faebee..085b33f 100644
--- a/board/matrix_vision/mvbc_p/mvbc_p.c
+++ b/board/matrix_vision/mvbc_p/mvbc_p.c
@@ -70,9 +70,9 @@ phys_addr_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/matrix_vision/mvsmr/mvsmr.c b/board/matrix_vision/mvsmr/mvsmr.c
index 2c51389..cb3bca3 100644
--- a/board/matrix_vision/mvsmr/mvsmr.c
+++ b/board/matrix_vision/mvsmr/mvsmr.c
@@ -81,9 +81,9 @@ phys_addr_t initdram(int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/mcc200/mcc200.c b/board/mcc200/mcc200.c
index 706886b..5f39f93 100644
--- a/board/mcc200/mcc200.c
+++ b/board/mcc200/mcc200.c
@@ -106,9 +106,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
@@ -134,10 +134,10 @@ phys_size_t initdram (int board_type)
 	/* find RAM size using SDRAM CS1 only */
 	if (!dramsize)
 		sdram_start(0);
-	test2 = test1 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
+	test2 = test1 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
 	if (!dramsize) {
 		sdram_start(1);
-		test2 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
+		test2 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
 	}
 	if (test1 > test2) {
 		sdram_start(0);
diff --git a/board/micronas/vct/vct.c b/board/micronas/vct/vct.c
index 0745cee..ad7d2d2 100644
--- a/board/micronas/vct/vct.c
+++ b/board/micronas/vct/vct.c
@@ -61,7 +61,7 @@ void _machine_restart(void)
  */
 phys_size_t initdram(int board_type)
 {
-	return get_ram_size((long *)CONFIG_SYS_SDRAM_BASE,
+	return get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE,
 			    CONFIG_SYS_MBYTES_SDRAM << 20);
 }
 
diff --git a/board/mimc/mimc200/mimc200.c b/board/mimc/mimc200/mimc200.c
index 2ad53ec..e061c00 100644
--- a/board/mimc/mimc200/mimc200.c
+++ b/board/mimc/mimc200/mimc200.c
@@ -155,7 +155,7 @@ phys_size_t initdram(int board_type)
 {
 	unsigned long expected_size;
 	unsigned long actual_size;
-	void *sdram_base;
+	unsigned long *sdram_base;
 
 	sdram_base = uncached(EBI_SDRAM_BASE);
 
diff --git a/board/miromico/hammerhead/hammerhead.c b/board/miromico/hammerhead/hammerhead.c
index d82fee7..6539705 100644
--- a/board/miromico/hammerhead/hammerhead.c
+++ b/board/miromico/hammerhead/hammerhead.c
@@ -78,7 +78,7 @@ phys_size_t initdram(int board_type)
 {
 	unsigned long expected_size;
 	unsigned long actual_size;
-	void *sdram_base;
+	unsigned long *sdram_base;
 
 	sdram_base = uncached(EBI_SDRAM_BASE);
 
diff --git a/board/motionpro/motionpro.c b/board/motionpro/motionpro.c
index a6235e5..3781136 100644
--- a/board/motionpro/motionpro.c
+++ b/board/motionpro/motionpro.c
@@ -137,9 +137,9 @@ phys_size_t initdram(int board_type)
 	*(vu_long *)MPC5XXX_SDRAM_CONFIG2 = SDRAM_CONFIG2;
 
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/muas3001/muas3001.c b/board/muas3001/muas3001.c
index 42b0a03..94f0c29 100644
--- a/board/muas3001/muas3001.c
+++ b/board/muas3001/muas3001.c
@@ -232,7 +232,7 @@ static long int try_init (volatile memctl8260_t * memctl, ulong sdmr,
 	*sdmr_ptr = sdmr | PSDMR_OP_NORM | PSDMR_RFEN;
 	*base = c;
 
-	size = get_ram_size ((long *)base, maxsize);
+	size = get_ram_size ((unsigned long *)base, maxsize);
 	*orx_ptr = orx | ~(size - 1);
 
 	return (size);
diff --git a/board/munices/munices.c b/board/munices/munices.c
index 319fa8c..7a2c0b3 100644
--- a/board/munices/munices.c
+++ b/board/munices/munices.c
@@ -83,9 +83,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = (ulong )get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x10000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x10000000);
 	sdram_start(1);
-	test2 = (ulong )get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x10000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x10000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/musenki/musenki.c b/board/musenki/musenki.c
index aa92fc4..fe5c497 100644
--- a/board/musenki/musenki.c
+++ b/board/musenki/musenki.c
@@ -32,10 +32,10 @@ int checkflash (void)
 
 phys_size_t initdram (int board_type)
 {
-	long size;
-	long new_bank0_end;
-	long mear1;
-	long emear1;
+	unsigned long size;
+	unsigned long new_bank0_end;
+	unsigned long mear1;
+	unsigned long emear1;
 
 	size = get_ram_size(CONFIG_SYS_SDRAM_BASE, CONFIG_SYS_MAX_RAM_SIZE);
 
diff --git a/board/mvblue/mvblue.c b/board/mvblue/mvblue.c
index 69abb06..723fed9 100644
--- a/board/mvblue/mvblue.c
+++ b/board/mvblue/mvblue.c
@@ -79,10 +79,10 @@ int checkboard (void)
 
 phys_size_t initdram (int board_type)
 {
-	long size;
-	long new_bank0_end;
-	long mear1;
-	long emear1;
+	unsigned long size;
+	unsigned long new_bank0_end;
+	unsigned long mear1;
+	unsigned long emear1;
 
 	size = get_ram_size(CONFIG_SYS_SDRAM_BASE, CONFIG_SYS_MAX_RAM_SIZE);
 
diff --git a/board/mx1ads/mx1ads.c b/board/mx1ads/mx1ads.c
index 4266048..dee209e 100644
--- a/board/mx1ads/mx1ads.c
+++ b/board/mx1ads/mx1ads.c
@@ -155,7 +155,7 @@ int board_late_init (void)
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM_1,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM_1,
 				PHYS_SDRAM_1_SIZE);
 	return 0;
 }
diff --git a/board/netphone/netphone.c b/board/netphone/netphone.c
index 053bdf1..2b7c6d3 100644
--- a/board/netphone/netphone.c
+++ b/board/netphone/netphone.c
@@ -447,7 +447,7 @@ phys_size_t initdram(int board_type)
 		}
 	}
 
-	size = get_ram_size((long *)0, SDRAM_MAX_SIZE);
+	size = (long int)get_ram_size((unsigned long *)0, SDRAM_MAX_SIZE);
 
 	if (size == 0) {
 		printf("SIZE is zero: LOOP on 0\n");
diff --git a/board/netta/netta.c b/board/netta/netta.c
index bfd51e7..ce00369 100644
--- a/board/netta/netta.c
+++ b/board/netta/netta.c
@@ -380,7 +380,7 @@ phys_size_t initdram(int board_type)
 		}
 	}
 
-	size = get_ram_size((long *)0, SDRAM_MAX_SIZE);
+	size = (long int)get_ram_size((unsigned long *)0, SDRAM_MAX_SIZE);
 
 #if 0
 	printf("check 0\n");
diff --git a/board/netta2/netta2.c b/board/netta2/netta2.c
index 362a3c7..962dd0b 100644
--- a/board/netta2/netta2.c
+++ b/board/netta2/netta2.c
@@ -445,7 +445,7 @@ phys_size_t initdram(int board_type)
 		}
 	}
 
-	size = get_ram_size((long *)0, SDRAM_MAX_SIZE);
+	size = (long int)get_ram_size((unsigned long *)0, SDRAM_MAX_SIZE);
 
 	if (size == 0) {
 		printf("SIZE is zero: LOOP on 0\n");
diff --git a/board/nx823/nx823.c b/board/nx823/nx823.c
index d49fa8c..b3fba69 100644
--- a/board/nx823/nx823.c
+++ b/board/nx823/nx823.c
@@ -342,7 +342,8 @@ static long int dram_size (long int mamr_value, long int *base,
 
 	memctl->memc_mamr = mamr_value;
 
-	return (get_ram_size (base, maxsize));
+	return (long int)(get_ram_size ((unsigned long *)base,
+				(unsigned long)maxsize));
 }
 
 int misc_init_r (void)
diff --git a/board/phytec/pcm030/pcm030.c b/board/phytec/pcm030/pcm030.c
index ce515d8..6cb6060 100644
--- a/board/phytec/pcm030/pcm030.c
+++ b/board/phytec/pcm030/pcm030.c
@@ -103,9 +103,9 @@ phys_size_t initdram(int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *) CONFIG_SYS_SDRAM_BASE, 0x10000000);
+	test1 = get_ram_size((unsigned long *) CONFIG_SYS_SDRAM_BASE, 0x10000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *) CONFIG_SYS_SDRAM_BASE, 0x10000000);
+	test2 = get_ram_size((unsigned long *) CONFIG_SYS_SDRAM_BASE, 0x10000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
diff --git a/board/pm520/pm520.c b/board/pm520/pm520.c
index 4ec4505..e3f85d2 100644
--- a/board/pm520/pm520.c
+++ b/board/pm520/pm520.c
@@ -93,9 +93,9 @@ phys_size_t initdram (int board_type)
 
 	/* find RAM size using SDRAM CS0 only */
 	sdram_start(0);
-	test1 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test1 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	sdram_start(1);
-	test2 = get_ram_size((long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
+	test2 = get_ram_size((unsigned long *)CONFIG_SYS_SDRAM_BASE, 0x80000000);
 	if (test1 > test2) {
 		sdram_start(0);
 		dramsize = test1;
@@ -121,10 +121,10 @@ phys_size_t initdram (int board_type)
 	/* find RAM size using SDRAM CS1 only */
 	if (!dramsize)
 		sdram_start(0);
-	test2 = test1 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
+	test2 = test1 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
 	if (!dramsize) {
 		sdram_start(1);
-		test2 = get_ram_size((long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
+		test2 = get_ram_size((unsigned long *)(CONFIG_SYS_SDRAM_BASE + dramsize), 0x80000000);
 	}
 	if (test1 > test2) {
 		sdram_start(0);
diff --git a/board/pm826/pm826.c b/board/pm826/pm826.c
index 93bb1b4..af55892 100644
--- a/board/pm826/pm826.c
+++ b/board/pm826/pm826.c
@@ -256,7 +256,7 @@ static long int try_init (volatile memctl8260_t * memctl, ulong sdmr,
 	*sdmr_ptr = sdmr | PSDMR_OP_NORM | PSDMR_RFEN;
 	*base = c;
 
-	size = get_ram_size((long *)base, maxsize);
+	size = get_ram_size((unsigned long *)base, maxsize);
 
 	*orx_ptr = orx | ~(size - 1);
 
diff --git a/board/pn62/pn62.c b/board/pn62/pn62.c
index 81829dd..a40617a 100644
--- a/board/pn62/pn62.c
+++ b/board/pn62/pn62.c
@@ -63,10 +63,10 @@ int checkboard (void)
 
 phys_size_t initdram (int board_type)
 {
-	long size;
-	long new_bank0_end;
-	long mear1;
-	long emear1;
+	unsigned long size;
+	unsigned long new_bank0_end;
+	unsigned long mear1;
+	unsigned long emear1;
 
 	show_startup_phase (2);
 
diff --git a/board/r360mpi/r360mpi.c b/board/r360mpi/r360mpi.c
index d06aea7..56ce26e 100644
--- a/board/r360mpi/r360mpi.c
+++ b/board/r360mpi/r360mpi.c
@@ -245,7 +245,7 @@ static long int dram_size (long int mamr_value,
 
 	memctl->memc_mamr = mamr_value;
 
-	return (get_ram_size(base, maxsize));
+	return (long int)(get_ram_size((unsigned long *)base, (unsigned long)maxsize));
 }
 
 /* ------------------------------------------------------------------------- */
diff --git a/board/rbc823/rbc823.c b/board/rbc823/rbc823.c
index f276e5e..7f1c03b 100644
--- a/board/rbc823/rbc823.c
+++ b/board/rbc823/rbc823.c
@@ -238,7 +238,8 @@ static long int dram_size (long int mamr_value, long int *base,
 
 	memctl->memc_mamr = mamr_value;
 
-	return (get_ram_size (base, maxsize));
+	return (long int)(get_ram_size ((unsigned long *)base,
+				(unsigned long)maxsize));
 }
 
 #ifdef CONFIG_CMD_DOC
diff --git a/board/ronetix/pm9261/pm9261.c b/board/ronetix/pm9261/pm9261.c
index a2a569b..a42cbe6 100644
--- a/board/ronetix/pm9261/pm9261.c
+++ b/board/ronetix/pm9261/pm9261.c
@@ -268,7 +268,7 @@ int board_eth_init(bd_t *bis)
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM,
 				PHYS_SDRAM_SIZE);
 	return 0;
 }
diff --git a/board/ronetix/pm9263/pm9263.c b/board/ronetix/pm9263/pm9263.c
index 48eba99..6998197 100644
--- a/board/ronetix/pm9263/pm9263.c
+++ b/board/ronetix/pm9263/pm9263.c
@@ -363,7 +363,7 @@ int board_init(void)
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM,
 				PHYS_SDRAM_SIZE);
 	return 0;
 }
diff --git a/board/ronetix/pm9g45/pm9g45.c b/board/ronetix/pm9g45/pm9g45.c
index 5bb5a3c..da2078d 100644
--- a/board/ronetix/pm9g45/pm9g45.c
+++ b/board/ronetix/pm9g45/pm9g45.c
@@ -146,7 +146,7 @@ int board_init(void)
 int dram_init(void)
 {
 	/* dram_init must store complete ramsize in gd->ram_size */
-	gd->ram_size = get_ram_size((void *)PHYS_SDRAM,
+	gd->ram_size = get_ram_size((unsigned long *)PHYS_SDRAM,
 				PHYS_SDRAM_SIZE);
 	return 0;
 }
diff --git a/board/samsung/arndale/arndale.c b/board/samsung/arndale/arndale.c
index 052fecd..9c1ffc5 100644
--- a/board/samsung/arndale/arndale.c
+++ b/board/samsung/arndale/arndale.c
@@ -24,7 +24,7 @@ int dram_init(void)
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++) {
 		addr = CONFIG_SYS_SDRAM_BASE + (i * SDRAM_BANK_SIZE);
-		gd->ram_size += get_ram_size((long *)addr, SDRAM_BANK_SIZE);
+		gd->ram_size += get_ram_size((unsigned long *)addr, SDRAM_BANK_SIZE);
 	}
 	return 0;
 }
@@ -42,7 +42,7 @@ void dram_init_banksize(void)
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++) {
 		addr = CONFIG_SYS_SDRAM_BASE + (i * SDRAM_BANK_SIZE);
-		size = get_ram_size((long *)addr, SDRAM_BANK_SIZE);
+		size = get_ram_size((unsigned long *)addr, SDRAM_BANK_SIZE);
 
 		gd->bd->bi_dram[i].start = addr;
 		gd->bd->bi_dram[i].size = size;
diff --git a/board/samsung/origen/origen.c b/board/samsung/origen/origen.c
index 15f77ca..79e2844 100644
--- a/board/samsung/origen/origen.c
+++ b/board/samsung/origen/origen.c
@@ -71,10 +71,14 @@ int board_early_init_f(void)
 
 int dram_init(void)
 {
-	gd->ram_size	= get_ram_size((long *)PHYS_SDRAM_1, PHYS_SDRAM_1_SIZE)
-			+ get_ram_size((long *)PHYS_SDRAM_2, PHYS_SDRAM_2_SIZE)
-			+ get_ram_size((long *)PHYS_SDRAM_3, PHYS_SDRAM_3_SIZE)
-			+ get_ram_size((long *)PHYS_SDRAM_4, PHYS_SDRAM_4_SIZE);
+	gd->ram_size	= get_ram_size((unsigned long *)PHYS_SDRAM_1,
+							PHYS_SDRAM_1_SIZE)
+			+ get_ram_size((unsigned long *)PHYS_SDRAM_2,
+							PHYS_SDRAM_2_SIZE)
+			+ get_ram_size((unsigned long *)PHYS_SDRAM_3,
+							PHYS_SDRAM_3_SIZE)
+			+ get_ram_size((unsigned long *)PHYS_SDRAM_4,
+							PHYS_SDRAM_4_SIZE);
 
 	return 0;
 }
@@ -82,16 +86,16 @@ int dram_init(void)
 void dram_init_banksize(void)
 {
 	gd->bd->bi_dram[0].start = PHYS_SDRAM_1;
-	gd->bd->bi_dram[0].size = get_ram_size((long *)PHYS_SDRAM_1, \
+	gd->bd->bi_dram[0].size = get_ram_size((unsigned long *)PHYS_SDRAM_1, \
 							PHYS_SDRAM_1_SIZE);
 	gd->bd->bi_dram[1].start = PHYS_SDRAM_2;
-	gd->bd->bi_dram[1].size = get_ram_size((long *)PHYS_SDRAM_2, \
+	gd->bd->bi_dram[1].size = get_ram_size((unsigned long *)PHYS_SDRAM_2, \
 							PHYS_SDRAM_2_SIZE);
 	gd->bd->bi_dram[2].start = PHYS_SDRAM_3;
-	gd->bd->bi_dram[2].size = get_ram_size((long *)PHYS_SDRAM_3, \
+	gd->bd->bi_dram[2].size = get_ram_size((unsigned long *)PHYS_SDRAM_3, \
 							PHYS_SDRAM_3_SIZE);
 	gd->bd->bi_dram[3].start = PHYS_SDRAM_4;
-	gd->bd->bi_dram[3].size = get_ram_size((long *)PHYS_SDRAM_4, \
+	gd->bd->bi_dram[3].size = get_ram_size((unsigned long *)PHYS_SDRAM_4, \
 							PHYS_SDRAM_4_SIZE);
 }
 
diff --git a/board/samsung/smdk5250/exynos5-dt.c b/board/samsung/smdk5250/exynos5-dt.c
index bb4a82f..d9e3b0f 100644
--- a/board/samsung/smdk5250/exynos5-dt.c
+++ b/board/samsung/smdk5250/exynos5-dt.c
@@ -134,11 +134,11 @@ int board_init(void)
 int dram_init(void)
 {
 	int i;
-	u32 addr;
+	unsigned long addr;
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++) {
 		addr = CONFIG_SYS_SDRAM_BASE + (i * SDRAM_BANK_SIZE);
-		gd->ram_size += get_ram_size((long *)addr, SDRAM_BANK_SIZE);
+		gd->ram_size += get_ram_size((unsigned long *)addr, SDRAM_BANK_SIZE);
 	}
 	return 0;
 }
@@ -263,11 +263,11 @@ int power_init_board(void)
 void dram_init_banksize(void)
 {
 	int i;
-	u32 addr, size;
+	unsigned long addr, size;
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++) {
 		addr = CONFIG_SYS_SDRAM_BASE + (i * SDRAM_BANK_SIZE);
-		size = get_ram_size((long *)addr, SDRAM_BANK_SIZE);
+		size = get_ram_size((unsigned long *)addr, SDRAM_BANK_SIZE);
 
 		gd->bd->bi_dram[i].start = addr;
 		gd->bd->bi_dram[i].size = size;
